package com.xeround.bankmark;

import java.util.Enumeration;

import javax.swing.JOptionPane;

public class AccountList {

	private static AccountList instance = null;
	protected static MyDoubleyList accountHoldingList;
	MyListIterator cursor;

	public MyListIterator getCursor() {
		return cursor;
	}

	public void setCursor(MyListIterator cursor) {
		this.cursor = cursor;
	}

	public AccountList() {
		accountHoldingList = new MyDoubleyList();
		cursor = this.head();
	}

	public MyDoubleyList getList() {
		return accountHoldingList;
	}

	public void setList(MyDoubleyList list) {
		accountHoldingList = list;
	}

	public long size() {
		return accountHoldingList.size();
	}

	public final boolean isEmpty() {
		return accountHoldingList.isEmpty();
	}// end isEmpty method

	public final synchronized void clear() {
		accountHoldingList.clear();
	}// end clear method

	public final synchronized void insertAfter(Object obj,
			MyListIterator insertAfterPosition) {
		accountHoldingList.insertAfter(obj, insertAfterPosition);
	}

	public final synchronized void insertBefore(Object obj,
			MyListIterator insertBeforePosition) {
		accountHoldingList.insertBefore(obj, insertBeforePosition);
	}

	public final synchronized void remove(MyListIterator removePosition) {
		accountHoldingList.remove(removePosition);
	}

	public final MyListIterator head() {
		return accountHoldingList.head();
	}

	public final MyListIterator find(Object thePassedObject) {
		return accountHoldingList.find(thePassedObject);
	}

	public final Enumeration<?> members() {
		return accountHoldingList.members();
	}

	public MyDoubleyList getAccountHoldingList() {
		return accountHoldingList;
	}

	public void setAccountHoldingList(MyDoubleyList accountHoldingList) {
		AccountList.accountHoldingList = accountHoldingList;
	}

	

	/*
	 * ///for checking that no duplicate account numbers exist public boolean
	 * accountAlreadyExists(String accountNumberFromJText) { boolean value =
	 * false; //i need to read about these booleans and default value :)
	 * MyListEnumerator thisEnumerator = (MyListEnumerator) this.members();
	 * while (thisEnumerator.hasMoreElements()) { Customer obj = (Customer)
	 * thisEnumerator.nextElement(); if
	 * (accountNumberFromJText.equals(obj.accountNumberToString())){ value =
	 * true; } } return value; } public boolean accountAlreadyExists2(int
	 * accountNumberFromJText) { MyListEnumerator thisEnumerator =
	 * (MyListEnumerator) this.members(); while
	 * (thisEnumerator.hasMoreElements()) { Account obj = (Account)
	 * thisEnumerator.nextElement(); if (obj.getAccountNumber() ==
	 * accountNumberFromJText){ System.out.println("match mother"); return true;
	 * } } return false; }
	 */
	// undo progress after previous save
	public void undoSaveAccounts() {
		SaveOpenLists undoAccounts = new SaveOpenLists();
		if (undoAccounts.getSaveAccountHoldingList() == null) {
			JOptionPane
					.showMessageDialog(null, "Can't Undo, No Previous Saves");
		} else {
			accountHoldingList = undoAccounts.getSaveAccountHoldingList();
		}
	}

	public static AccountList getInstance() {
		if (instance == null) {
			instance = new AccountList();
		}
		return instance;
	}

}
