package com.xeround.bankmark;

import java.awt.Window;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JLabel;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JTextField;
import java.awt.Color;
import javax.swing.JButton;
import java.awt.Font;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Enumeration;

import javax.swing.ButtonGroup;
import javax.swing.JTextArea;

public class AddNewAccountGUI extends JFrame {

	/**
	 * if (!(customerJlist.isSelectionEmpty())){}
	 */
	private static final long serialVersionUID = 4865875451327006390L;
	private static AddNewAccountGUI instance = null;
	private JPanel contentPane;
	final Window container = this;
	private JTextField openingBal;
	private JTextField transFee;
	private JTextField freeTransNumber;
	private JTextField interestRate;
	private JTextField fixedMonthlyCharge;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	SelectedFromButtonGroup bgSelected = new SelectedFromButtonGroup(); // check
	private MyListIterator cursor; // Class
	String newAccountTypeFromRadio;// long name but needed for remembering
	private String checkingString = "Checking";
	private String goldString = "Gold";
	private String regularString = "Regular";
	JList<Customer> customerJlist = new JList<Customer>();
	JTextArea textAreaCustInfo = new JTextArea();
	private Customer selectedCustomer;
	private MyListModel forJList = new MyListModel();
	private int freeTransactions, accNum;
	private double openingBalance, transactionFee, intRate, monthlyCharge;
	private JTextField accountNumber;

	/**
	 * Create the frame.
	 */
	public AddNewAccountGUI() {
		accountNumber = new JTextField();
		cursor = AccountList.getInstance().getCursor();
		setTitle("Add New Account");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 675, 400);
		contentPane = new JPanel();
		container.add(contentPane);
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		// populate list here to insure data integrity
		forJList.customerPopulateJList(customerJlist);
		// setting all fields to disabled until user selects account type

		// customerJlist.setSelectedIndex(selectedIndex);
		customerJlist.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				if (evt.getValueIsAdjusting()) {
					textAreaCustInfo.setText(customerJlist.getSelectedValue()
							.custAllInfotoString());
					setSelectedCustomer(customerJlist.getSelectedValue());
				}
			}
		});
		JRadioButton rdbtnChecking = new JRadioButton("Checking");
		rdbtnChecking.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// radio button will make sure a customer is selected
				if (!(customerJlist.isSelectionEmpty())) {
					newAccountTypeFromRadio = bgSelected
							.getSelectedButton(buttonGroup);
				
					openingBal.setEnabled(true);
					transFee.setEnabled(true);
					freeTransNumber.setEnabled(true);
					interestRate.setEnabled(false);
					fixedMonthlyCharge.setEnabled(false);
				} else {
					buttonGroup.clearSelection();
					JOptionPane.showMessageDialog(null,
							"Select A Customer to\n add account for");
				}
			}
		});
		buttonGroup.add(rdbtnChecking);

		JLabel lblAccountType = new JLabel("Account Type:");
		lblAccountType.setFont(new Font("Tahoma", Font.PLAIN, 14));
		lblAccountType.setForeground(new Color(0, 51, 255));

		JRadioButton rdbtnRegular = new JRadioButton("Regular");
		rdbtnRegular.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				newAccountTypeFromRadio = bgSelected
						.getSelectedButton(buttonGroup);
			
				openingBal.setEnabled(true);
				transFee.setEnabled(false);
				freeTransNumber.setEnabled(false);
				interestRate.setEnabled(true);
				fixedMonthlyCharge.setEnabled(true);
			}
		});
		buttonGroup.add(rdbtnRegular);

		JRadioButton rdbtnGold = new JRadioButton("Gold");
		rdbtnGold.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				newAccountTypeFromRadio = bgSelected
						.getSelectedButton(buttonGroup);
		
				openingBal.setEnabled(true);
				transFee.setEnabled(false);
				freeTransNumber.setEnabled(false);
				interestRate.setEnabled(true);
				fixedMonthlyCharge.setEnabled(true);
			}
		});
		buttonGroup.add(rdbtnGold);

		JLabel lblAccountNumber = new JLabel("Account Number:");
		lblAccountNumber.setFont(new Font("Tahoma", Font.PLAIN, 12));

		JLabel lblOpeningBalance = new JLabel("Opening Balance:");
		lblOpeningBalance.setFont(new Font("Tahoma", Font.PLAIN, 12));

		openingBal = new JTextField();
		openingBal.setEnabled(false);
		openingBal.setColumns(10);

		JLabel lblTransactionFees = new JLabel("Transaction Fees:");
		lblTransactionFees.setFont(new Font("Tahoma", Font.PLAIN, 12));

		transFee = new JTextField();
		transFee.setEnabled(false);
		transFee.setColumns(10);

		JLabel lblNumberOfFree = new JLabel("Number of Free Transactions:");
		lblNumberOfFree.setFont(new Font("Tahoma", Font.PLAIN, 12));

		freeTransNumber = new JTextField();
		freeTransNumber.setEnabled(false);
		freeTransNumber.setColumns(10);

		JLabel lblFixedInterestRate = new JLabel("Fixed Interest Rate:");
		lblFixedInterestRate.setFont(new Font("Tahoma", Font.PLAIN, 12));

		interestRate = new JTextField();
		interestRate.setEnabled(false);
		interestRate.setColumns(10);

		JLabel lblFixedMonthlyCharge = new JLabel("Fixed Monthly Charge:");
		lblFixedMonthlyCharge.setFont(new Font("Tahoma", Font.PLAIN, 12));

		fixedMonthlyCharge = new JTextField();
		fixedMonthlyCharge.setEnabled(false);
		fixedMonthlyCharge.setColumns(10);

		JButton btnClose = new JButton("Close");
		btnClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				container.dispose();
			}
		});

		JButton btnAdd = new JButton("Add");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (newAccountTypeFromRadio == regularString) {
					//JOptionPane.showMessageDialog(null, "Regular Account");
					///////////////////
					try {
						setOpeningBalance(Double.parseDouble(openingBal.getText()));
						setIntRate(Double.parseDouble(interestRate.getText()));
						setMonthlyCharge(Double.parseDouble(fixedMonthlyCharge.getText()));
						setAccNum(Integer.parseInt(accountNumber.getText()));
						setSelectedCustomer(customerJlist.getSelectedValue());
						//can make new regular account now
						RegularAccount newRegular = new RegularAccount(selectedCustomer,
								getOpeningBalance(), getAccNum());
						
						newRegular.setMonthlyCharge(getMonthlyCharge());
						newRegular.setInterestRate(getIntRate());				
						//insert into AccountList
				
						AccountList.getInstance().getAccountHoldingList().insertAfter(newRegular, cursor);
						System.out.print("hah");
						//System.out.print("ok");
						forJList.customerPopulateJList(customerJlist);
					} catch (Exception exc) {
						JOptionPane.showMessageDialog(null, "Must Enter a Dollar Amount");
						//return;
					}
				}
				if (newAccountTypeFromRadio == goldString) {
					//JOptionPane.showMessageDialog(null, "Gold Account");
					setSelectedCustomer(customerJlist.getSelectedValue());
					try {
						setOpeningBalance(Double.parseDouble(openingBal.getText()));
						setIntRate(Double.parseDouble(interestRate.getText()));
						setMonthlyCharge(Double.parseDouble(fixedMonthlyCharge.getText()));
						setAccNum(Integer.parseInt(accountNumber.getText()));
						//can make new checking account now
						GoldAccount newGold = new GoldAccount(customerJlist.getSelectedValue(),
								getOpeningBalance(), getAccNum());		
						newGold.setMonthlyCharge(getMonthlyCharge());
						newGold.setInterestRate(getIntRate());				
						//insert into AccountList
					
						AccountList.getInstance().getAccountHoldingList().insertAfter(newGold, cursor);
						System.out.print("okfghfghfghfgh");
						forJList.customerPopulateJList(customerJlist);
				
					} catch (Exception exc) {
					JOptionPane.showMessageDialog(null, "Must Enter a Dollar Amount");
						//return;
					}
				
				}
				//using try catch for validation until i get better at regular expressions
				if (newAccountTypeFromRadio == checkingString) {	
					setSelectedCustomer(customerJlist.getSelectedValue());
					try {		
						
						setFreeTransactions(Integer.parseInt(freeTransNumber.getText()));									
					} catch (Exception exc) {
						
						JOptionPane.showMessageDialog(null, "Must be a Number");
						//return;
					}
					try {
						setOpeningBalance(Double.parseDouble(openingBal.getText()));			
						setTransactionFee(Double.parseDouble(transFee.getText()));
						setFreeTransactions(Integer.parseInt(freeTransNumber.getText()));
						setAccNum(Integer.parseInt(accountNumber.getText()));
						//can make new checking account now
						System.out.println("made it");
						CheckingAccount newChecking = new CheckingAccount(customerJlist.getSelectedValue(),
								getOpeningBalance(), getAccNum());	
						newChecking.setFreeTransactions(getFreeTransactions());
						newChecking.setTransactionFee(getTransactionFee());
						
						//insert into AccountList
					
						System.out.println("made it");
					
						AccountList.getInstance().getAccountHoldingList().insertAfter(newChecking, cursor);
						System.out.println("made it line 260 error here");
						
						/////big error here
						forJList.customerPopulateJList(customerJlist);
					} catch (Exception exc) {
						JOptionPane.showMessageDialog(null, "Need Proper Input");
						//return;
					}
				}
			}
		});

		JLabel lblSelectACustomer = new JLabel("Select A Customer");
		lblSelectACustomer.setForeground(new Color(0, 51, 255));
		lblSelectACustomer.setFont(new Font("Tahoma", Font.PLAIN, 14));

		JLabel lblOpenBalError = new JLabel("");
		lblOpenBalError.setForeground(new Color(255, 0, 0));

		textAreaCustInfo.setEditable(false);
		textAreaCustInfo.setBackground(Color.LIGHT_GRAY);
		
		
		accountNumber.setColumns(10);

		GroupLayout gl_contentPane = new GroupLayout(contentPane);
		gl_contentPane.setHorizontalGroup(
			gl_contentPane.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING, false)
						.addComponent(lblSelectACustomer)
						.addComponent(customerJlist, GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE)
						.addComponent(textAreaCustInfo, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(40)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
						.addComponent(lblAccountType)
						.addComponent(lblOpeningBalance)
						.addComponent(lblAccountNumber)
						.addComponent(lblTransactionFees)
						.addComponent(lblNumberOfFree)
						.addComponent(lblFixedInterestRate)
						.addComponent(lblFixedMonthlyCharge))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_contentPane.createSequentialGroup()
									.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
										.addGroup(gl_contentPane.createSequentialGroup()
											.addGap(18)
											.addComponent(rdbtnChecking))
										.addComponent(openingBal, 87, 87, 87)
										.addComponent(transFee, 87, 87, 87)
										.addComponent(freeTransNumber, 87, 87, 87)
										.addComponent(interestRate, 87, 87, 87)
										.addComponent(fixedMonthlyCharge, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
										.addComponent(lblOpenBalError, GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)
										.addGroup(gl_contentPane.createSequentialGroup()
											.addComponent(rdbtnRegular)
											.addPreferredGap(ComponentPlacement.UNRELATED)
											.addComponent(rdbtnGold))))
								.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING, false)
									.addComponent(btnClose, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
									.addComponent(btnAdd, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 116, Short.MAX_VALUE)))
							.addGap(91))
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(accountNumber, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addContainerGap())))
		);
		gl_contentPane.setVerticalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGap(12)
							.addComponent(lblSelectACustomer)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING, false)
								.addGroup(gl_contentPane.createSequentialGroup()
									.addGap(13)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
										.addComponent(lblAccountNumber)
										.addComponent(accountNumber, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
									.addGap(8)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
										.addComponent(lblOpeningBalance)
										.addComponent(openingBal, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
										.addComponent(lblOpenBalError, GroupLayout.PREFERRED_SIZE, 20, GroupLayout.PREFERRED_SIZE))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
										.addComponent(lblTransactionFees)
										.addComponent(transFee, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
										.addComponent(lblNumberOfFree)
										.addComponent(freeTransNumber, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
										.addComponent(lblFixedInterestRate)
										.addComponent(interestRate, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
								.addGroup(gl_contentPane.createSequentialGroup()
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(customerJlist, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
								.addComponent(fixedMonthlyCharge, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(lblFixedMonthlyCharge)))
						.addGroup(gl_contentPane.createSequentialGroup()
							.addContainerGap()
							.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
								.addComponent(rdbtnChecking)
								.addComponent(rdbtnRegular)
								.addComponent(rdbtnGold)
								.addComponent(lblAccountType))))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(btnAdd)
							.addGap(18)
							.addComponent(btnClose))
						.addComponent(textAreaCustInfo, GroupLayout.DEFAULT_SIZE, 139, Short.MAX_VALUE))
					.addContainerGap())
		);
		contentPane.setLayout(gl_contentPane);
		setLocation(600, 200);
	}

	public Customer getSelectedCustomer() {
		return selectedCustomer;
	}

	public void setSelectedCustomer(Customer selectedCustomer) {
		this.selectedCustomer = selectedCustomer;
	}


	public double getOpeningBalance() {
		return openingBalance;
	}

	public void setOpeningBalance(double openingBalance) {
		this.openingBalance = openingBalance;
	}

	public double getTransactionFee() {
		return transactionFee;
	}

	public void setTransactionFee(double transactionFee) {
		this.transactionFee = transactionFee;
	}

	public int getFreeTransactions() {
		return freeTransactions;
	}

	public void setFreeTransactions(int freeTransactions) {
		this.freeTransactions = freeTransactions;
	}

	public double getIntRate() {
		return intRate;
	}

	public void setIntRate(double intRate) {
		this.intRate = intRate;
	}

	public double getMonthlyCharge() {
		return monthlyCharge;
	}

	public void setMonthlyCharge(double monthlyCharge) {
		this.monthlyCharge = monthlyCharge;
	}

	public boolean alreadyExists(String accountNumber) {
		MyDoubleyList accDoubley = AccountList.getInstance()
				.getAccountHoldingList();
		Enumeration<?> doubleEn = accDoubley.members();
		while (doubleEn.hasMoreElements()) {
			Account obj = (Account) doubleEn.nextElement();
			if (obj.getAccountNumberToString() == accountNumber) {
				JOptionPane.showMessageDialog(null, "Account Number In Use");
				return true;
			}
		}
		return false;
	}

	public int getAccNum() {
		return accNum;
	}

	public void setAccNum(int accNum) {
		this.accNum = accNum;
	}
	public static AddNewAccountGUI getInstance() {
		if (instance == null) {
			instance = new AddNewAccountGUI();
		}
		return instance;
	}
}
