package com.xeround.bankmark;

import java.io.Serializable;

public class Customer implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1692460009030411796L;
	private String customerName;
	private int customerID;
	private String customerAddress;
	private String customerPhone;
	private CustomerList customerList;
	/*
	 * //NewCustomerGUI has these fields to retrieve from form private
	 * JTextField custName; private JTextField custAddress; private JTextField
	 * custPhone; private JTextField custID;
	 */

	public Customer(String name, String address, String phone, int id) {
		customerName = name;
		customerAddress = address;
		customerPhone = phone;
		customerID = id;
	}

	public void setCustomerName(String name) {
		customerName = name;
	}

	public String getCustomerName() {
		return customerName;
	}

	public int getCustomerID() {
		return customerID;
	}

	public void setCustomerID(int id) {
		customerID = id;
	}

	public String toString() {
		String customerInfo =  getCustomerName();
		return String.format("%s", customerInfo);
	}
	public String custAllInfotoString() {
		String customerInfo = getCustomerName() + "\n" +
				getCustomerAddress() + "\n" + getCustomerPhone() + "\n" +
				getCustomerID() + "\n";
		return String.format("%s", customerInfo);
	}
	public String custNameToString() {
		String customerInfo = getCustomerName();
		return String.format("%s", customerInfo);
	}
	public String custAddressToString() {
		String customerInfo = getCustomerAddress();
		return String.format("%s", customerInfo);
	}
	public String custPhoneToString() {
		String customerInfo = getCustomerPhone();
		return String.format("%s", customerInfo);
	}
	public String custIDToString() {
		int customerInfo = getCustomerID();
		return String.format("%s", customerInfo);
	}

	public String getCustomerAddress() {
		return customerAddress;
	}

	public void setCustomerAddress(String address) {
		customerAddress = address;
	}

	public String getCustomerPhone() {
		return customerPhone;
	}

	public void setCustomerPhone(String phone) {
		customerPhone = phone;

	}

	public CustomerList getCustomerList() {
		return customerList;
	}

	public void setCustomerList(CustomerList customerList) {
		this.customerList = customerList;
	}
}
