package com.xeround.bankmark;

import java.util.Enumeration;
import java.util.NoSuchElementException;

import javax.swing.JOptionPane;

public class CustomerList {

	private static CustomerList instance = null;
	protected static MyDoubleyList customerHoldingList;
	MyListIterator cursor;

	public MyListIterator getCursor() {
		return cursor;
	}

	public void setCursor(MyListIterator cursor) {
		this.cursor = cursor;
	}

	public CustomerList() {		
		customerHoldingList = new MyDoubleyList();
		cursor = this.head();
		//MyListIterator iterator = new MyListIterator(customerHoldingList, listItem);
	}


	///######### Getters and Setters
	public void setCustomerHoldingList(MyDoubleyList custHoldingList) {
		customerHoldingList = custHoldingList;
	}
	public MyDoubleyList getCustomerHoldingList() {
		return customerHoldingList;
	}
	
	//List methods
	public long size() {
		return customerHoldingList.size();
	}
	public final boolean isEmpty() {
		return customerHoldingList.isEmpty();
	}// end isEmpty method

	public final void clear() {
		customerHoldingList.clear();
	}// end clear method
	public final void insertAfter(Object obj,
			MyListIterator insertAfterPosition) {
		customerHoldingList.insertAfter(obj, insertAfterPosition);
	}

	public final void insertBefore(Object obj,
			MyListIterator insertBeforePosition) {
		customerHoldingList.insertBefore(obj, insertBeforePosition);
	}

	public final void remove(MyListIterator removePosition) {
		customerHoldingList.remove(removePosition);
	}

	public final MyListIterator head() {
		return customerHoldingList.head();
	}

	public final MyListIterator find(Object thePassedObject) {
		return customerHoldingList.find(thePassedObject);
	}

	public final Enumeration<?> members() {
		return customerHoldingList.members();
	}
	
	///Cool stuff --- undoing save --- so if the list has changed since previous 
	//version then can undo. If the SaveOpenLists object is null --- nullpointerException
	//so will have to check first
	public void undoSaveCustomers(){
		customerHoldingList = SaveOpenLists.getInstance().getSaveCustomerHoldingList();	
	}
	//used to get existing instance so instantiation is not necessary
	public static CustomerList getInstance() {
	      if(instance == null) {
	         instance = new CustomerList();
	      }
	      return instance;
	   }
}
