package com.xeround.bankmark;
import java.io.Serializable;
import java.util.*;

import javax.swing.JOptionPane;

final class MyListEnumerator implements Enumeration<Object>, Serializable{ // object types
																/**
	 * 
	 */
	private static final long serialVersionUID = 2034325268547152538L;
	// for accounts
																// which
	// i am going to serialize
	MyDoubleyList theDoublyList; // points to the doubly linkedList to
									// enumerate,
	/*
	 * TODO I need to define enumertion type somehow. defined by integer for
	 * accountNumber probably
	 */
	MyListIterator pointingAt; // where or what position the iterator is
								// pointingAt

	MyListEnumerator(MyDoubleyList theDoublyList) { // constructor passes the
													// list and assigns
		// it to this class's field variable
		this.theDoublyList = theDoublyList; // assignment
		pointingAt = theDoublyList.head(); // now point to head
		pointingAt.next(); // now move position to point at next position

	}

	// hasMoreElements goes thru the list and makes sure that the list position
	// is
	// not pointing at the head, and when it does list is empty, so this method
	// will return true as long as there s another element, false if no more
	// good for running loops
	public boolean hasMoreElements() {
		return pointingAt.position != theDoublyList.head;
	}

	// nextElement method returns the nextThing in the list
	// but have to check if the head is being pointed at first
	public Object nextElement() {
		Object nextThing = null;
		synchronized (theDoublyList) {
			try {
				if (pointingAt.position != theDoublyList.head) {
					nextThing = pointingAt.position.objectThing;
					pointingAt.next();
				}
			} catch (NoSuchElementException objectNonExisting) {
				JOptionPane.showMessageDialog(null, "Account does not exist");
			}
			// have to handle this exception if object passed is not oe of the
			// Account objects
		}
		return nextThing; // nextThing object is null here if it doesn't exist
							// because it
		// never gets set to anything --- not sure if this is okay???
	}
}//end MyListEnumerator
