package com.xeround.bankmark;

import java.io.Serializable;

final class MyListIterator implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 4826215215421428116L;
	MyDoubleyList traversingList; // list to traverse, I'm passing it the list
									// of accounts
	// Accounts from MyDoublyList methods (insertAfter and insertBefore)
	MyListItem position; // has the object and previous and next fields

	MyListIterator(MyDoubleyList traversingList, MyListItem position) {
		this.traversingList = traversingList;
		this.position = position;
	}

	// check iterator ownership
	public boolean belongsTo(Object traversingList) { // checks to see if the
														// Account object
		// belongsTo this iterator
		return this.traversingList == traversingList;
	}

	// head method moves iterator position to the front or head
	public void head() {
		position = traversingList.head;
	}// end head method

	// traverse to next position
	public void next() {
		position = position.next;
	}// end next
	
	public MyListItem nextPosition() {
		position = position.next;
		return position;
	}// end next

	// travel or move position to previous
	public void previous() {
		position = position.previous;
	}// end previous method
}// end MyListIterator

