package com.xeround.bankmark;

import java.util.Enumeration;

import javax.swing.AbstractButton;
import javax.swing.ButtonGroup;

//this class uses an enumeration of abstracButton type to return the text of the radio
//button that is being selected. The text is then set to a string variable 'buttonSelectedFromRadio'
//and compared to another string variable with if statement
	public class SelectedFromButtonGroup {

	    public String getSelectedButton(ButtonGroup bg) {
	    	
	        for (Enumeration<AbstractButton> radiobuttons = bg.getElements(); 
	        		radiobuttons.hasMoreElements();) {
	            AbstractButton button = radiobuttons.nextElement();

	            if (button.isSelected()) {
	                return button.getText();
	            }
	        }
	        return null;
	    }
	    
	}
	//this class was written to eliminate nested if statements and event listeners every time
	//it is necessary to see what options are selected.
