package com.xeround.bankmark;

import java.io.Serializable;

final class MyListItem implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4772818372905675023L;
	Object objectThing; // variable for an object in the list
	MyListItem previous, next; // variables for pointing at the previous and
								// next nodes

	// constructor takes an object
	// and assigns the values of null to previous and next
	public MyListItem(Object obj) {
		this(null, obj, null);
	}// end constructor

	// constructor is passed the previous and next listItem and assigns them to
	// the classes variables
	public MyListItem(MyListItem previous, Object objectThing, MyListItem next) {
		this.previous = previous;
		this.objectThing = objectThing;
		this.next = next;
	}// end constructor
}// end MyListItem

